#####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#####################################################################################
# ignores.tcl v1.0
# :
#   (    claim.tcl)
# 
# :     scripts
#  eggdrop.conf  source scripts/ignores.tcl
#
# .chanset #channel -/+nopubignore - / 
# .chanset #channel -/+stillignore - /  
#####################################################################################


namespace eval ignore {}

setudef flag nopubignore
setudef flag stillignore

set ignore(suff) "!"

bind pub mnoyl|mnoyl $ignore(suff)+badchan ::ignore::ignore
bind pub mnoyl|mnoyl $ignore(suff)-badchan ::ignore::delignore
bind pub mnoyl|mnoyl $ignore(suff)badchans ::ignore::read
bind pub mnoyl|mnoyl $ignore(suff)fignore ::ignore::findignore
bind pub mno|- $ignore(suff)-badchanall ::ignore::clearignore
bind pub mnoyl|mnoyl $claim(suff)+helpclaim ::ignore::helpignore

set cnb 0
set ignore(data) "ignore.txt"

set ignore(name) "ignore.tcl"
set ignore(ver) "1.02"
set ignore(auth) "Adium @ RusNet"


proc ::ignore::ignore { nick uhost hand chan text } {
	global ignore
	if {[channel get $chan nopubignore]} { return }
	if {![file exists "$ignore(data)"]} {
		::egglib::writedata $ignore(data) ""
	}
	set text [join [lrange [split $text] 0 end]]
	set data [::egglib::readdata $ignore(data)]
	set reas ""
	set channel [join [lindex $text 0]]
	set reas [join [lrange $text 1 end]]

	if {![string match "#*" $channel] || [string match "" $channel] || $reas == ""} {
		 if {![channel get $chan stillignore]} {
		 		::egglib::out $nick $chan "\003:\002 $ignore(suff)+badchan <#> < >\002\003"
		 } else {
		 		putserv "notice $nick :\003:\002 $ignore(suff)+badchan <#> < >\002\003"
		 }
		 return
	}

	if { $channel == ""} {
		 if {![channel get $chan stillignore]} { 
		 		::egglib::out $nick $chan "\003    .\003"
		 		::egglib::out $nick $chan "\003:\002 $ignore(suff)+badchan <#> < >\002\003"
		 } else {
		 		putserv "notice $nick :\003   .\003"
		 		putserv "notice $nick :\003:\002 $ignore(suff)+badchan <#> < >\002\003"
		 }
		 return	
	}
                if { $reas == ""} {
                            if {![channel get $chan stillignore]} {
                                                                ::egglib::out $nick $chan "\003   .\003"
                                                                ::egglib::out $nick $chan "\003:\002 $ignore(suff)+badchan <#> < >\002\003"
                                  } else {
                                  putserv "notice $nick :\003   .\003"
                                  putserv "notice $nick :\003:\002 $ignore(suff)+badchan <#> < >\002\003"
                                  }
                                  return
                 }

	set data2 [::egglib::readdata "$ignore(data)"]

	foreach a $data2 {
		if {[lindex $a 0] == "$channel"} {
			 if {![channel get $chan stillignore]} { 
		 	 		::egglib::out $nick $chan "\003   \002$channel\002  . \002 $ignore(suff)fignore <#>\002\003"
		 	 } else {
		 	 	  putserv "\003   \002$channel\002  . \002 $ignore(suff)fignore <#>\002\003"
		 	 }
		 	 return
		}
	}

	set all "$channel $nick $reas"
	set data [linsert $data end $all]
	::egglib::writedata "$ignore(data)" $data
	if {![channel get $chan stillignore]} {
		 ::egglib::out $nick $chan "\003  .\003"
	} else {
		 putserv "notice $nick :\003  .\003"
}

proc ::ignore::delignore { nick uhost hand chan text } {
	global ignore
	set text [join [lrange [split $text] 0 end]]
	set data [::egglib::readdata "$ignore(data)"]
	set arg [join [lindex $text 0]]
	set hand [nick2hand $nick $chan]
	if {$data == ""} {
		 putserv "notice $nick :\003     .\003"
		 return
	}
	if {![string match "#*" $arg] || ($text == "") || ([llength $data] < $text)} {
		 if {![channel get $chan stillignore]} {
		 		::egglib::out $nick $chan "\003:\002 $ignore(suff)-badchan <#>\002\003"
		 } else {
		 		putserv "notice $nick :\003:\002 $ignore(suff)-badchan <#>\002\003"
		 }
		 return
	}

	set num "0"
	foreach a $data {
	    set kanal [lindex $a 0]
	    if { $arg != $kanal } {
		incr num
	    }
	}
	if { $num == "0" } {incr num}
	set data [lreplace $data [expr $num - 1] [expr $num - 1]]
	::egglib::writedata "$ignore(data)" $data
	if {![channel get $chan stillignore]} {
		 		::egglib::out $nick $chan "\003  \002$text\002 .\003"
	} else {
		 		putserv "notice $nick :\003  \002$text\002 .\003"
	}
}

proc ::ignore::read { nick uhost hand chan text } {
	global cnb ignore
	set data [::egglib::readdata $ignore(data)]
	set ln ""

	if {$data == ""} { 
		 putserv "notice $nick :\003     .\003"
		 return
	}
	
	foreach res $data {
		incr cnb
		set cl_count "[join [lrange $res 2 end]]"

		if {![channel get $chan stillignore]} {
		    putserv "PRIVMSG $nick :\003:\002 [lindex $res 0]\002 :\002 [lindex $res 1]\002 :\002 $cl_count\002\003"
		    } else {
		    putserv "notice $nick :\003:\002 [lindex $res 0]\002 :\002 [lindex $res 1]\002 :\002 $cl_count\002\003"
		    }
		}
	}
	
	if {[info exists tmp]} {
		 if {$cnb < $tmp} {
		 	if {![channel get $chan stillignore]} {
				 ::egglib::out $nick $chan "\00310  .\003"
			} else {
				 putserv "notice $nick :\00310  .\003"
			}
		 }
		 
		 if {![string match "" $ln]} {
		 		if {![channel get $chan stillignore]} {
		 			 ::egglib::out $nick $chan "\002\[$text/$cnb\]\002 $ln"
		 		} else {
		 			 putserv "notice $nick :\002\[$text/$cnb\]\002 $ln"
		 		}
		 }
	}
	
	set cnb 0
}

proc ::ignore::findignore { nick uhost hand chan text } {
global ignore
	set text [join [lrange [split $text] 0 end]]
	set channel [join [lindex $text 0]]
	set data [::egglib::readdata "$ignore(data)"]
	if { $channel == "" } {
		if {![channel get $chan stillignore]} {
		::egglib::out $nick $chan "\0033   . ,\0034 $ignore(suff)fignore\00314 <\0034#\00314>\003"
		} else {
		putserv "notice $nick \0033   . ,\0034 $ignore(suff)fignore\00314 <\0034#\00314>\003"
		return
		}
	}
	if {![string match "#*" $channel]} {
		if {![channel get $chan stillignore]} {
		::egglib::out $nick $chan "\0033     \0034#\003"
		} else {
		putserv "notice $nick :\0033     \0034#\003"
		}

	}

	set i 0
	foreach res $data {
		set cl_count "[join [lrange $res 2 end]]"
		if {[lindex $res 0] == "$channel"} {
			incr i
			putserv "NOTICE $nick :\0033:\00314 [lindex $res 0]\0033 :\00314 [lindex $res 1]\0033 :\00314 $cl_count\003"
		}
	}
if { $i == "0" } {
putserv "NOTICE $nick :\0033 \0034$channel \0033    \0034 "
return
}
}

proc ::ignore::clearignore { nick uhost hand chan text } {
   global ignore
   ::egglib::writedata "$ignore(data)" ""
   putserv "notice $nick :\003  .\003"
}

proc ::ignore::helpignore { nick uhost hand chan text } {
	global ignore
	if {[channel get $chan nopubignore]} { return }
	set hand [nick2hand $nick $chan]
	set ap "; "
	set text1 "\00310   :\003"
	set text2 "\0034$ignore(suff)+badchan\00314 <\0034#\00314> <\0034 \00314>\003"
	set text3 "\0034$ignore(suff)-badchan \00314<\0034#\00314> -   <#>   \003"
	set text4 "\0034$ignore(suff)badchans\00314 -   \003"
	set text5 "\0034$ignore(suff)-badchanall\00314 -   \003"

	set txt1 $text1
	set txt2 $text2
	append txt2 $ap
	append txt2 $text3
	append txt2 $ap
	append txt2 $text4
	append txt2 $ap
	append txt2 $text5
	::egglib::outm $nick $txt1
	::egglib::outm $nick $txt2
	return
}

putlog "\002$ignore(name)\002 v$ignore(ver) by $ignore(auth) loaded."
